#!/bin/sh
#====================================================
# gmsigcap 1.0b - geekmaster vector signature capture
# Copyright (C) 2012 by geekmaster, with MIT license:
# http://www.opensource.org/licenses/mit-license.php
#----------------------------------------------------
# Tested on K5main,K5diags, uses touchscreen.
#----------------------------------------------------

#===========================
# initvar - init global vars
#---------------------------
initvar() {
  gs=12 # granularity size (distance per capture point)
  DN=/dev/null; DZ=/dev/zero; DF=/dev/fb0
  DT=$(for i in /dev/input/event*;do evtest info $i|grep zforce>$DN&&echo $i&&break;done)
  set $(eips -i|grep line_length); VX=$4
  W='\xff';W=$W$W$W$W$W$W;W=$W$W$W$W$W;W=$W$W$W$W$W;W=$W$W$W$W # 600px white
  eips -c -f # flash clear
  x=0 y=0 xs=0 ys0=0 B=0 Q=0 n=0 H="" R='\x0d' GG=$((gs*gs))
  eips 44 38 '+~~~~~'
  eips 44 39 '| Exit'
}

#=================================
# abortsh - abort subprocess shell
#---------------------------------
abortsh() {
  set $(ps a|grep "sh -c hexdump $DT")
  kill -HUP $1 # abort shell
  Q=1 # signal quit
}

#==================================
# sigcap - signature vector capture
#----------------------------------
sigcap() {
  script -c "hexdump $DT" $DN|while [[ $Q -eq 0 ]]; do
    read L; [[ ${#L} -ne 48 ]]&& break # rare script exit output
    set $L; local T=$((0x$6)) C=$((0x$7)) V=$((0x$8))
    case $T in
    0) if [[ $B -eq 9 ]]; then
        H="$H 0 };$R\x0a"; n=$((n+1))
        echo -e "unsigned short int sigvec[$n]={$R"; echo -e "$H$R"
        abortsh # abort subprocess shell
        Q=1 # signal quit
      elif [[ $x -ge 540 && $y -ge 750 ]]; then # on exit button
        if [[ $B -ne 1 ]]; then # was not pressed
          eips -v 44 38 '+~~~~~'
          eips -v 44 39 '| Exit'
        fi; B=1
      else # off exit button
        if [[ $B -ne 2 ]]; then # was not released
          eips 44 38 '+~~~~~'
          eips 44 39 '| Exit'
        fi; B=2
      fi
      Dx=$((x-xs)); [[ $Dx -lt 0 ]]&& Dx=$((0-Dx))
      Dy=$((y-ys)); [[ $Dy -lt 0 ]]&& Dy=$((0-Dy))
      RR=$((Dx*Dx+Dy*Dy))
      if [[ $RR -ge $GG ]];then
        H="$H $((y*256/800*256+x*256/600)),$R\x0a"; n=$((n+1))
        dd if=$DZ of=$DF bs=1 count=5 seek=$((y*VX+x-4)) 2>$DN # black
        xs=$x ys=$y; eips '';
      fi ;;
    3) case $C in
      53) x=$((V*600/4096)) ;;
      54) y=$((V*800/4096)) ;;
      57) case $V in
        0) xs=0 ys=0 ;;
        65535) [[ $B -eq 1 ]]&& B=9 # signal exit button pressed
          H="$H $((y*256/800*256+x*256/600)),$R\x0a"
          H="$H 0,$R\x0a"; n=$((n+2)) ;;
        esac ;;
      esac ;;
    esac
  done
  eips 44 38 '      '
  eips 44 39 '      '
}

killall -STOP Xorg cvm # pause framework
initvar # init global vars
sigcap # signature vector capture
killall -CONT cvm Xorg # resume framework
